"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.EthPayload = exports.Participant = exports.Params = exports.protobufPackage = void 0;
/* eslint-disable */
const long_1 = __importDefault(require("long"));
const minimal_1 = __importDefault(require("protobufjs/minimal"));
exports.protobufPackage = "cerc.onboarding.v1";
function createBaseParams() {
    return { onboardingEnabled: false };
}
exports.Params = {
    encode(message, writer = minimal_1.default.Writer.create()) {
        if (message.onboardingEnabled === true) {
            writer.uint32(8).bool(message.onboardingEnabled);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseParams();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.onboardingEnabled = reader.bool();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            onboardingEnabled: isSet(object.onboardingEnabled)
                ? Boolean(object.onboardingEnabled)
                : false,
        };
    },
    toJSON(message) {
        const obj = {};
        message.onboardingEnabled !== undefined &&
            (obj.onboardingEnabled = message.onboardingEnabled);
        return obj;
    },
    fromPartial(object) {
        var _a;
        const message = createBaseParams();
        message.onboardingEnabled = (_a = object.onboardingEnabled) !== null && _a !== void 0 ? _a : false;
        return message;
    },
};
function createBaseParticipant() {
    return { cosmosAddress: "", nitroAddress: "" };
}
exports.Participant = {
    encode(message, writer = minimal_1.default.Writer.create()) {
        if (message.cosmosAddress !== "") {
            writer.uint32(10).string(message.cosmosAddress);
        }
        if (message.nitroAddress !== "") {
            writer.uint32(18).string(message.nitroAddress);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseParticipant();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.cosmosAddress = reader.string();
                    break;
                case 2:
                    message.nitroAddress = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            cosmosAddress: isSet(object.cosmosAddress)
                ? String(object.cosmosAddress)
                : "",
            nitroAddress: isSet(object.nitroAddress)
                ? String(object.nitroAddress)
                : "",
        };
    },
    toJSON(message) {
        const obj = {};
        message.cosmosAddress !== undefined &&
            (obj.cosmosAddress = message.cosmosAddress);
        message.nitroAddress !== undefined &&
            (obj.nitroAddress = message.nitroAddress);
        return obj;
    },
    fromPartial(object) {
        var _a, _b;
        const message = createBaseParticipant();
        message.cosmosAddress = (_a = object.cosmosAddress) !== null && _a !== void 0 ? _a : "";
        message.nitroAddress = (_b = object.nitroAddress) !== null && _b !== void 0 ? _b : "";
        return message;
    },
};
function createBaseEthPayload() {
    return { address: "", msg: "" };
}
exports.EthPayload = {
    encode(message, writer = minimal_1.default.Writer.create()) {
        if (message.address !== "") {
            writer.uint32(10).string(message.address);
        }
        if (message.msg !== "") {
            writer.uint32(18).string(message.msg);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseEthPayload();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.address = reader.string();
                    break;
                case 2:
                    message.msg = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            address: isSet(object.address) ? String(object.address) : "",
            msg: isSet(object.msg) ? String(object.msg) : "",
        };
    },
    toJSON(message) {
        const obj = {};
        message.address !== undefined && (obj.address = message.address);
        message.msg !== undefined && (obj.msg = message.msg);
        return obj;
    },
    fromPartial(object) {
        var _a, _b;
        const message = createBaseEthPayload();
        message.address = (_a = object.address) !== null && _a !== void 0 ? _a : "";
        message.msg = (_b = object.msg) !== null && _b !== void 0 ? _b : "";
        return message;
    },
};
if (minimal_1.default.util.Long !== long_1.default) {
    minimal_1.default.util.Long = long_1.default;
    minimal_1.default.configure();
}
function isSet(value) {
    return value !== null && value !== undefined;
}
