"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MsgClientImpl = exports.MsgOnboardParticipantResponse = exports.MsgOnboardParticipant = exports.protobufPackage = void 0;
/* eslint-disable */
const onboarding_1 = require("./onboarding");
const long_1 = __importDefault(require("long"));
const minimal_1 = __importDefault(require("protobufjs/minimal"));
exports.protobufPackage = "cerc.onboarding.v1";
function createBaseMsgOnboardParticipant() {
    return { participant: "", ethPayload: undefined, ethSignature: "" };
}
exports.MsgOnboardParticipant = {
    encode(message, writer = minimal_1.default.Writer.create()) {
        if (message.participant !== "") {
            writer.uint32(10).string(message.participant);
        }
        if (message.ethPayload !== undefined) {
            onboarding_1.EthPayload.encode(message.ethPayload, writer.uint32(18).fork()).ldelim();
        }
        if (message.ethSignature !== "") {
            writer.uint32(26).string(message.ethSignature);
        }
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMsgOnboardParticipant();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                case 1:
                    message.participant = reader.string();
                    break;
                case 2:
                    message.ethPayload = onboarding_1.EthPayload.decode(reader, reader.uint32());
                    break;
                case 3:
                    message.ethSignature = reader.string();
                    break;
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(object) {
        return {
            participant: isSet(object.participant) ? String(object.participant) : "",
            ethPayload: isSet(object.ethPayload)
                ? onboarding_1.EthPayload.fromJSON(object.ethPayload)
                : undefined,
            ethSignature: isSet(object.ethSignature)
                ? String(object.ethSignature)
                : "",
        };
    },
    toJSON(message) {
        const obj = {};
        message.participant !== undefined &&
            (obj.participant = message.participant);
        message.ethPayload !== undefined &&
            (obj.ethPayload = message.ethPayload
                ? onboarding_1.EthPayload.toJSON(message.ethPayload)
                : undefined);
        message.ethSignature !== undefined &&
            (obj.ethSignature = message.ethSignature);
        return obj;
    },
    fromPartial(object) {
        var _a, _b;
        const message = createBaseMsgOnboardParticipant();
        message.participant = (_a = object.participant) !== null && _a !== void 0 ? _a : "";
        message.ethPayload =
            object.ethPayload !== undefined && object.ethPayload !== null
                ? onboarding_1.EthPayload.fromPartial(object.ethPayload)
                : undefined;
        message.ethSignature = (_b = object.ethSignature) !== null && _b !== void 0 ? _b : "";
        return message;
    },
};
function createBaseMsgOnboardParticipantResponse() {
    return {};
}
exports.MsgOnboardParticipantResponse = {
    encode(_, writer = minimal_1.default.Writer.create()) {
        return writer;
    },
    decode(input, length) {
        const reader = input instanceof minimal_1.default.Reader ? input : new minimal_1.default.Reader(input);
        let end = length === undefined ? reader.len : reader.pos + length;
        const message = createBaseMsgOnboardParticipantResponse();
        while (reader.pos < end) {
            const tag = reader.uint32();
            switch (tag >>> 3) {
                default:
                    reader.skipType(tag & 7);
                    break;
            }
        }
        return message;
    },
    fromJSON(_) {
        return {};
    },
    toJSON(_) {
        const obj = {};
        return obj;
    },
    fromPartial(_) {
        const message = createBaseMsgOnboardParticipantResponse();
        return message;
    },
};
class MsgClientImpl {
    constructor(rpc) {
        this.rpc = rpc;
        this.OnboardParticipant = this.OnboardParticipant.bind(this);
    }
    OnboardParticipant(request) {
        const data = exports.MsgOnboardParticipant.encode(request).finish();
        const promise = this.rpc.request("cerc.onboarding.v1.Msg", "OnboardParticipant", data);
        return promise.then((data) => exports.MsgOnboardParticipantResponse.decode(new minimal_1.default.Reader(data)));
    }
}
exports.MsgClientImpl = MsgClientImpl;
if (minimal_1.default.util.Long !== long_1.default) {
    minimal_1.default.util.Long = long_1.default;
    minimal_1.default.configure();
}
function isSet(value) {
    return value !== null && value !== undefined;
}
